//--------------------------------------------------------------------------------------
// JCSDK.h
// SDKӿڶ
//--------------------------------------------------------------------------------------

#pragma once

#ifdef __cplusplus
#  define JCSDK_API extern "C" __declspec(dllexport)
#else
#  define JCSDK_API __declspec(dllexport)
#endif

#define JCSDK_CALLTYPE __stdcall

#define JCSDK_INVALID_LINKVALUE -1
typedef int JCLink_t;

#define JCMAX_LINKNUM 512

//¼
enum JCEventType
{
	//Ӳ
	JCET_Connected, //δʹ
	JCET_ConnectOK,	//ӳɹ
	JCET_UserAccessError, //û֤ʧ
	JCET_NoChannel,		//ͨδ
	JCET_ConTypeError,	//ʹ
	JCET_ConCountLimit,	//
	JCET_ConTimeout,	//ӳʱ
	JCET_DisconOK, //Ͽӳɹ
	JCET_ConAbout, //쳣Ͽ
	JCET_ServiceStop,	//ضϿ

	//Զ¼
	JCET_GetFileListOK,		//ȡԶ¼ɹ
	JCET_GetFileListError,	//ȡԶ¼ʧ

	JCET_RemotePlayBegin,	//Զ̻طſʼ
	JCET_RemotePlayEnd,		//Զ̻طŽ
	JCET_RemoteError,		//Զ̻طʧ
	JCET_RemotePlayTimeout,	//Զ̻طóʱ

	JCET_DownloadData,		//¼
	JCET_DownloadEnd,		//¼
	JCET_DownloadStop,		//¼ֹͣ
	JCET_DownloadError,		//Զʧ
	JCET_DownloadTimeout,	//Զسʱ

	//
	JCET_StreamReset,	//ź(øı,رղ¿롢¼)
	JCET_Alarm,	//ź
};

//״̬
enum JCLinkStatus
{
	JCLS_UnConnect,	//δ
	JCLS_Connecting,//
	JCLS_WaitData,	//ӳɹȴ
	JCLS_Connected,	//
};

//֡
enum JCFrameType
{
	JCFT_I,			//ƵI֡
	JCFT_P,			//ƵP֡
	JCFT_B,			//ƵB֡
	JCFT_Audio,		//Ƶ֡
};

//¼
enum JCRecFileType
{
	JCRT_Unknown = 0,//δ֪
	JCRT_SV4,		//sv4ļ
	JCRT_SV5,		//sv5ļ
	JCRT_SV6,		//sv6ļ
	JCRT_MP4,		//MP4ļ
};

//豸
enum JCDeviceType
{
	JCDT_All = 0,		//δ֪豸
	JCDT_Card,			//Ƶɼ
	JCDT_DVR,			//DVR
	JCDT_IPC,			//IPC
	JCDT_NVR,			//NVR
};

//
enum JCCodecID
{
	JCCID_Unknown,		//δ֪

	//Ƶ
	JCCID_JENC04,		//ά04
	JCCID_H264,			//H264

	//Ƶ
	JCCID_PCM,			//PCM
	JCCID_AMR,			//AMR
	JCCID_G711A,		//G711A
	JCCID_G711U,		//G711U
};

//֡
typedef struct _JCStreamFrame
{
	JCFrameType sType;
	PUCHAR pFrameData;
	int nFrameSize;
}
JCStreamFrame, *PJCStreamFrame;

//豸Ϣ
typedef struct _JCLanDeviceInfo
{
	char szCloudSEE[16];
	char szIP[16];
	int nPort;
	char szDeviceName[128];
	int nDeviceType;
	int nChannelNum;
}
JCLanDeviceInfo, *PJCLanDeviceInfo;

//豸Ϣ
typedef struct _JCDeviceInfo
{
	JCDeviceType eDevType;
}
JCDeviceInfo, *PJCDeviceInfo;

//Ϣ
typedef struct _JCStreamInfo
{
	JCCodecID eVideoCodec;		//Ƶ
	int nFrameWidth;			//Ƶ֡
	int nFrameHeight;			//Ƶ֡߶
	int nVideoFrameRateNum;		//Ƶ֡ʷ
	int nVideoFrameRateDen;		//Ƶ֡ʷĸ

	JCCodecID eAudioCodec;		//Ƶ
	int nAudioSamples;			//Ƶ
	int nAudioSampleBits;		//Ƶλ
	int nAudioChannels;			//Ƶͨ

	JCRecFileType eRecFileType;	//¼ļ
}
JCStreamInfo, *PJCStreamInfo;

//ڶ
typedef struct _JCDateBlock
{
	int nBeginYear;		//ʼ
	int nBeginMonth;	//ʼ·
	int nBeginDay;		//ʼ
	int nEndYear;		//
	int nEndMonth;		//·
	int nEndDay;		//
}
JCDateBlock, *PJCDateBlock;

//¼Ϣ
typedef struct _JCRecFileInfo
{
	int nRecFileID;
	JCRecFileType eType;
	char szBeginTime[8];
	char szFilename[16];
	char szPathName[64];
}
JCRecFileInfo, *PJCRecFileInfo;

//yv12֡
typedef struct _JCRawFrame
{
	DWORD dwWidth;
	DWORD dwHeight;
	PUCHAR pY;
	PUCHAR pU;
	PUCHAR pV;
	DWORD dwYPitch;
	DWORD dwUPitch;
	DWORD dwVPitch;
}
JCRawFrame, *PJCRawFrame;

//ص
typedef void (__cdecl *JCEventCallback_t)(JCLink_t nLinkID, JCEventType etType, DWORD_PTR pData1, DWORD_PTR pData2, LPVOID pUserData);
typedef void (__cdecl *JCDataCallback_t)(JCLink_t nLinkID, PJCStreamFrame pFrame, LPVOID pUserData);
typedef void (__cdecl *JCRawDataCallback_t)(JCLink_t nLinkID, PJCRawFrame pFrame, LPVOID pUserData);
typedef void (__cdecl *JCLanSearchDeviceCallback_t)(PJCLanDeviceInfo pDevice);

//ȫֺ------------------------------------------------------------------------------
//ʼSDK
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_InitSDK(int nLocStartPort);

//ͷSDK
JCSDK_API void JCSDK_CALLTYPE JCSDK_ReleaseSDK();

//ûص
JCSDK_API void JCSDK_CALLTYPE JCSDK_RegisterCallback(
	JCEventCallback_t funEventCallback,
	JCDataCallback_t funDataCallback,
	JCRawDataCallback_t funRawDataCallback,
	JCLanSearchDeviceCallback_t funLanSearchDeviceCallback);

//-----------------------------------------------------------------------------------
//
JCSDK_API JCLink_t JCSDK_CALLTYPE JCSDK_Connect(char *szServer, int nPort, int nChannel,
	char *szNetUser, char *szPwd, BOOL bNumOrIP, LPVOID pUserData);

//Ͽ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_Disconnect(JCLink_t nLinkID);

//ȡ豸Ϣ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_GetDeviceInfo(JCLink_t nLinkID, PJCDeviceInfo pDevInfo);

//Ԥ-------------------------------------------------------------------------------
//
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_EnableDecoder(JCLink_t nLinkID, BOOL bEnable);

//ƵԤ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_SetVideoPreview(JCLink_t nLinkID, HWND hWnd, LPRECT pRect);

//ƵԤ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_SetAudioPreview(JCLink_t nLinkID, HWND hWnd);

//ȡϢ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_GetStreamInfo(JCLink_t nLinkID, PJCStreamInfo pInfo);

//¼-------------------------------------------------------------------------------
//¼
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_StartRec(JCLink_t nLinkID, char *szFilename);

//ر¼
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_StopRec(JCLink_t nLinkID);

//Զ̲-------------------------------------------------------------------------------
//Զ¼
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_GetRemoteRecFileList(JCLink_t nLinkID, PJCDateBlock pDate);

//Զ̻ط
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_RemotePlay(JCLink_t nLinkID, int nFileID);

//Զ¼
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_DownloadRemoteFile(JCLink_t nLinkID, int nFileID);

//Զ¼
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_RemoteRecording(JCLink_t nLinkID, BOOL bEnable);

//-----------------------------------------------------------------------------------
//豸
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_LanSeartchDevice(int nDeviceType, DWORD dwTimeout);

//ͼ
JCSDK_API BOOL JCSDK_CALLTYPE JCSDK_SaveBitmap(JCLink_t nLinkID, char *szFilename);

//Զ(ֻ֧IPC),nLanguage:0,1Ӣ
JCSDK_API BOOL JCSDK_CALLTYPE JVSDK_RemoteConfig(JCLink_t nLinkID, int nLanguage);

JCSDK_API void JCSDK_CALLTYPE JCSDK_yv12_to_rgb32(PUCHAR pDest, DWORD dwDestPitch, PUCHAR pSrcY, PUCHAR pSrcU, PUCHAR pSrcV, 
	DWORD dwSrcYPitch, DWORD dwSrcUPitch, DWORD dwSrcVPitch, DWORD dwWidth, DWORD dwHeight);
